google.load("visualization", "1", {
    packages: ["corechart", "line", "columnchart"]
});

var chart;

var chartOptions = {
    width: "100%" /*400*/,
    height: "100%" /*300*/,
    backgroundColor: '#daeef3',
    fontname: 'Verdana, Geneva, sans-serif',

    is3D: true, //for bar charts

    title: 'Υψόμετρο (από την επιφάνεια της θάλασσας) προς απόσταση',
    legend: 'none',

    hAxis: {
        //title: '# Δείκτη',
        /**/title: 'Απόσταση (km)',
        viewWindowMode: 'pretty'
    },
    vAxis: {
        title: 'Υψόμετρο (m)',
        viewWindowMode: 'pretty'
    },

    focusTarget: 'category', //make  entire category's tooltip active (needed for custom HTML tooltip)

    tooltip: {
        isHtml: true, // Use an HTML tooltip
        //trigger: 'selection' //show (persistent) tooltip on selection, not on focus
    }
};

var _chartSelectionChangedCallback;

function initChart(chartSelectionChangedCallback) {
    _chartSelectionChangedCallback = chartSelectionChangedCallback;
}

function setChartSelection(row) {
    if (chart != null)
        chart.setSelection((row != -1)? [{"row": row, "column":1}] : []);
}

function onChartSelection(e) {
    var selection = chart.getSelection([e]); //note: if currently selected datapoint is clicked, selection is emptied ([] received)
    var dataPointIndex = (selection.length != 0)? selection[0].row : -1; //using -1 for deselection

    if (_chartSelectionChangedCallback != null)
        _chartSelectionChangedCallback(dataPointIndex);
}

function plotElevationsDistances(elevations, distances, selectionCallback) {
    //console.log('elevations: ', JSON.stringify(elevations));
    //console.log('distances: ', JSON.stringify(distances));
    
    chart =
        //new google.visualization.ColumnChart(document.getElementById('chart_div')); 
        /**/new google.visualization.LineChart(document.getElementById('chart_div'));

    // Add data selection handler:
    google.visualization.events.addListener(chart, 'select', onChartSelection);
    google.visualization.events.addListener(chart, 'onmouseover', function(e){
          chart.setSelection([{row: e.row, column: e.column}]);
          onChartSelection(e);
    });

    var data = new google.visualization.DataTable();
    //data.addColumn('string', '# Δείκτη');
    /**/data.addColumn('number', 'Απόσταση (km)');
    data.addColumn('number', 'Υψόμετρο (m)');
    data.addColumn({type: 'string', role: 'tooltip', 'p': {'html': true}});

    var elevationCount = elevations.length;
    if(elevationCount == 0)
        data.addRow([0,0,'']); //dummy data to hide the "No data" label
    else
        for (var i = 0; i < elevationCount; i++)
            data.addRow([
                /*''*/distances[i],
                elevations[i],
                '<div class="chartTooltip" onClick="$(this).closest(\'.google-visualization-tooltip\').hide()">Απόσταση: <strong>' + localizedNum(distances[i]) + ' km</strong><br />Υψόμετρο: <strong>' + localizedNum(elevations[i]) + ' m</strong></div><div class="chartTooltipCloseBtn" onClick="$(this).closest(\'.google-visualization-tooltip\').hide()" draggable="false" title="Κλείσιμο" aria-label="Κλείσιμο" type="button" onClick ><img class="chartTooltipCloseBtnImg" src="data:image/svg+xml,%3Csvg%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20width%3D%2224px%22%20height%3D%2224px%22%20viewBox%3D%220%200%2024%2024%22%20fill%3D%22%23000000%22%3E%0A%20%20%20%20%3Cpath%20d%3D%22M19%206.41L17.59%205%2012%2010.59%206.41%205%205%206.41%2010.59%2012%205%2017.59%206.41%2019%2012%2013.41%2017.59%2019%2019%2017.59%2013.41%2012z%22%2F%3E%0A%20%20%20%20%3Cpath%20d%3D%22M0%200h24v24H0z%22%20fill%3D%22none%22%2F%3E%0A%3C%2Fsvg%3E%0A"></button>'
                ]); //TODO: custom HTML tooltips don't seem to work, shows standard one

    chart.draw(data, chartOptions);
}

function clearChart() {
    document.getElementById('chart_div').innerHTML = '<h3 style="text-align:center">Χώρος για το διάγραμμα</h3>';
}
